OpenWRT的包依赖 package DEPEND

转载自:http://blog.chinaunix.net/uid-27057175-id-5011775.html

OpenWRT平台的package管理有自己的Makefile,不同于gcc的Makefile,
这个Makefile是作为OpenWRT强大的package管理的关键组件。
要想往OpenWRT添加自己的package,就得按照它的方式去写个pack依赖。
有了这个,target的pack运行时依赖的所有标准、第三方、自己的组件都可以在编译时一并解决依赖问题了,
而不是等到下载到板子上才发现缺少库。

举个例子,一个常见的openwrt package Makefile如下:

最常见的形式就是
DEPENDS:=+libpread
表示一旦你选中mypack,那么libpthread也就会同时被后台默认选中,推荐。

DEPENDS:=libpread
意味着因为依赖关系,只有在先选中libpthread后,才可以选择mypack。

DEPENDS:=+arpd:libpthread
这是一个双重依赖,只有arpd选中后,才可以选择libpthread,这样看有些拗口。
但是在前面取个反就很实用了,比如这个定义
DEPENDS:=+!BUSYBOX_CONFIG_arp:net-tools-arp
表示若busybox的arp没有包含(busybox的工具都是阉割版),那么就选中arp(标准版)。

DEPENDS:=@libpread
表示除非你先选中libpread,否则休想在menuconfig看到mypack。不推荐

DEPENDS:=+@libpthread
多个+呢,和+libpthread类似,会自动选择libpthread。
但是,有一点这种方式在安装mypack到target文件系统时,不会去检查依赖性的,若libpthread没有被安装它是检测不出来的,
只能在target上运行时才能发现 undefined symbol

发表评论

电子邮件地址不会被公开。 必填项已用*标注